searchNodes=[{"doc":"Minimal HTTP ClickHouse client","ref":"Ch.html","title":"Ch","type":"module"},{"doc":"","ref":"Ch.html#child_spec/1","title":"Ch.child_spec/1","type":"function"},{"doc":"","ref":"Ch.html#query/4","title":"Ch.query/4","type":"function"},{"doc":"","ref":"Ch.html#query!/4","title":"Ch.query!/4","type":"function"},{"doc":"","ref":"Ch.html#start_link/1","title":"Ch.start_link/1","type":"function"},{"doc":"Result struct returned from any successful query. Its fields are: command - An atom of the query command, for example: :select , :insert ; rows - The result set. One of: a list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; raw iodata when the response is not automatically decoded, e.g. x-clickhouse-format: CSV num_rows - The number of fetched or affected rows; meta - A map of metadata collected from the response headers like x-clickhouse-format , x-clickhouse-query-id , x-clickhouse-summary , etc.","ref":"Ch.Result.html","title":"Ch.Result","type":"module"},{"doc":"","ref":"Ch.Result.html#t:summary/0","title":"Ch.Result.summary/0","type":"type"},{"doc":"","ref":"Ch.Result.html#t:t/0","title":"Ch.Result.t/0","type":"type"},{"doc":"Minimal HTTP ClickHouse client. tl;dr iex&gt; Mix . install ( [ { :ch , github : &quot;plausible/ch&quot; } ] ) # https://clickhouse.com/docs/en/quick-start#step-3-create-a-database-and-table iex&gt; { :ok , conn } = Ch . start_link ( scheme : &quot;http&quot; , hostname : &quot;localhost&quot; , port : 8123 ) iex&gt; { :ok , _ } = Ch . query ( conn , &quot;CREATE DATABASE IF NOT EXISTS helloworld&quot; ) iex&gt; { :ok , _ } = Ch . query ( conn , &quot;&quot;&quot; CREATE TABLE helloworld.my_first_table ( user_id UInt32, message String, timestamp DateTime, metric Float32 ) ENGINE = MergeTree() PRIMARY KEY (user_id, timestamp) &quot;&quot;&quot; ) iex&gt; { :ok , %{ num_rows : 1 } } = Ch . query ( conn , &quot;INSERT INTO helloworld.my_first_table VALUES (0, {$0:String}, now(), {$1:Float32})&quot; , [ &quot;test&quot; , - 1.0 ] ) iex&gt; { :ok , _ } = Ch . query ( conn , &quot;DELETE FROM helloworld.my_first_table WHERE user_id = 0&quot; , [ ] , settings : [ allow_experimental_lightweight_delete : 1 ] ) iex&gt; types = [ :u32 , :string , :datetime , :f32 ] iex&gt; rows = [ [ 101 , &quot;Hello, ClickHouse!&quot; , ~N[2023-01-06 03:50:38] , - 1.0 ] , [ 102 , &quot;Insert a lot of rows per batch&quot; , ~N[2023-01-05 00:00:00] , 1.41421 ] , [ 102 , &quot;Sort your data based on your commonly-used queries&quot; , ~N[2023-01-06 00:00:00] , 2.718 ] , [ 101 , &quot;Granules are the smallest chunks of data read&quot; , ~N[2023-01-06 03:55:38] , 3.14159 ] ] iex&gt; stream = Stream . map ( rows , fn row -&gt; Ch.RowBinary . encode_row ( row , types ) end ) iex&gt; { :ok , %{ num_rows : 4 } } = Ch . query ( conn , &quot;INSERT INTO helloworld.my_first_table(user_id, message, timestamp, metric) FORMAT RowBinary&quot; , stream ) iex&gt; { :ok , %{ rows : rows } } = Ch . query ( conn , &quot;SELECT * FROM helloworld.my_first_table&quot; ) iex&gt; rows [ [ 101 , &quot;Hello, ClickHouse!&quot; , ~N[2023-01-06 03:50:38] , - 1.0 ] , [ 101 , &quot;Granules are the smallest chunks of data read&quot; , ~N[2023-01-06 03:55:38] , 3.141590118408203 ] , [ 102 , &quot;Insert a lot of rows per batch&quot; , ~N[2023-01-05 00:00:00] , 1.4142099618911743 ] , [ 102 , &quot;Sort your data based on your commonly-used queries&quot; , ~N[2023-01-06 00:00:00] , 2.7179999351501465 ] ] iex&gt; { :ok , %{ rows : rows } } = Ch . query ( conn , &quot;SELECT * FROM helloworld.my_first_table WHERE user_id = {user_id:Int8}&quot; , %{ &quot;user_id&quot; =&gt; 101 } ) iex&gt; rows [ [ 101 , &quot;Hello, ClickHouse!&quot; , ~N[2023-01-06 03:50:38] , - 1.0 ] , [ 101 , &quot;Granules are the smallest chunks of data read&quot; , ~N[2023-01-06 03:55:38] , 3.141590118408203 ] ] iex&gt; { :ok , %{ rows : csv } } = Ch . query ( conn , &quot;SELECT * FROM helloworld.my_first_table&quot; , [ ] , format : &quot;CSV&quot; ) iex&gt; IO . puts ( csv ) 101 , &quot;Hello, ClickHouse!&quot; , &quot;2023-01-06 03:50:38&quot; , - 1 101 , &quot;Granules are the smallest chunks of data read&quot; , &quot;2023-01-06 03:55:38&quot; , 3.14159 102 , &quot;Insert a lot of rows per batch&quot; , &quot;2023-01-05 00:00:00&quot; , 1.41421 102 , &quot;Sort your data based on your commonly-used queries&quot; , &quot;2023-01-06 00:00:00&quot; , 2.718 Examples Queries with parameters # https://clickhouse.com/docs/en/interfaces/http/#cli-queries-with-parameters statement = &quot;SELECT {a:Array(UInt8)}, {b:UInt8}, {c:String}, {d:DateTime}&quot; params = %{ a : [ 1 , 2 ] , b : 123 , c : &quot;123&quot; , d : ~N[2023-01-06 03:06:32] } { :ok , %{ num_rows : 1 , rows : [ [ [ 1 , 2 ] , 123 , &quot;123&quot; , ~N[2023-01-06 03:06:32] ] ] } } = Ch . query ( conn , statement , params ) CSV inserts { :ok , _ } = Ch . query ( conn , &quot;CREATE TABLE example(a UInt32, b String) ENGINE=Memory&quot; ) csv = &quot;&quot;&quot; 1,a 2,b 3,c \\ &quot;&quot;&quot; File . write! ( &quot;example.csv&quot; , csv ) { :ok , _ } = Ch . query ( conn , &quot;INSERT INTO example(a, b) FORMAT CSV&quot; , File . stream! ( &quot;example.csv&quot; ) ) CSV with headers inserts csv = &quot;&quot;&quot; a,b 1,a 2,b 3,c \\ &quot;&quot;&quot; File . write! ( &quot;example.csv&quot; , csv ) { :ok , _ } = Ch . query ( conn , &quot;INSERT INTO example FORMAT CSVWithNames&quot; , File . stream! ( &quot;example.csv&quot; ) ) Custom settings iex&gt; Ch . query ( conn , &quot;SHOW SETTINGS LIKE &#39;async_insert&#39;&quot; , [ ] , settings : [ async_insert : 1 ] ) { :ok , %{ num_rows : 1 , rows : [ [ &quot;async_insert&quot; , &quot;Bool&quot; , &quot;1&quot; ] ] } } iex&gt; Ch . query ( conn , &quot;CREATE TABLE example3(a UInt8) ENGINE=Memory&quot; , [ ] , settings : [ readonly : 1 ] ) { :error , % Ch.Error { code : 164 , message : &quot;Code: 164. DB::Exception: default: Cannot execute query in readonly mode. (READONLY) (version 22.10.1.1175 (official build)) \\n &quot; } }","ref":"readme.html","title":"README","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unlreleased","title":"Changelog - Unlreleased","type":"extras"}]